// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from data_tamer_msgs:msg/Schema.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "data_tamer_msgs/msg/schema.hpp"


#ifndef DATA_TAMER_MSGS__MSG__DETAIL__SCHEMA__STRUCT_HPP_
#define DATA_TAMER_MSGS__MSG__DETAIL__SCHEMA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__data_tamer_msgs__msg__Schema __attribute__((deprecated))
#else
# define DEPRECATED__data_tamer_msgs__msg__Schema __declspec(deprecated)
#endif

namespace data_tamer_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Schema_
{
  using Type = Schema_<ContainerAllocator>;

  explicit Schema_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->hash = 0ull;
      this->channel_name = "";
      this->schema_text = "";
    }
  }

  explicit Schema_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : channel_name(_alloc),
    schema_text(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->hash = 0ull;
      this->channel_name = "";
      this->schema_text = "";
    }
  }

  // field types and members
  using _hash_type =
    uint64_t;
  _hash_type hash;
  using _channel_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _channel_name_type channel_name;
  using _schema_text_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _schema_text_type schema_text;

  // setters for named parameter idiom
  Type & set__hash(
    const uint64_t & _arg)
  {
    this->hash = _arg;
    return *this;
  }
  Type & set__channel_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->channel_name = _arg;
    return *this;
  }
  Type & set__schema_text(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->schema_text = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    data_tamer_msgs::msg::Schema_<ContainerAllocator> *;
  using ConstRawPtr =
    const data_tamer_msgs::msg::Schema_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      data_tamer_msgs::msg::Schema_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      data_tamer_msgs::msg::Schema_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__data_tamer_msgs__msg__Schema
    std::shared_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__data_tamer_msgs__msg__Schema
    std::shared_ptr<data_tamer_msgs::msg::Schema_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Schema_ & other) const
  {
    if (this->hash != other.hash) {
      return false;
    }
    if (this->channel_name != other.channel_name) {
      return false;
    }
    if (this->schema_text != other.schema_text) {
      return false;
    }
    return true;
  }
  bool operator!=(const Schema_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Schema_

// alias to use template instance with default allocator
using Schema =
  data_tamer_msgs::msg::Schema_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace data_tamer_msgs

#endif  // DATA_TAMER_MSGS__MSG__DETAIL__SCHEMA__STRUCT_HPP_
